/* tslint:disable */
/* eslint-disable */
/**
 * vouchery.v1
 * DEPRECATED
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface UpdatePointsRequest
 */
export interface UpdatePointsRequest {
    /**
     * 
     * @type {number}
     * @memberof UpdatePointsRequest
     */
    amount: number;
    /**
     * 
     * @type {string}
     * @memberof UpdatePointsRequest
     */
    type: UpdatePointsRequestTypeEnum;
}

/**
    * @export
    * @enum {string}
    */
export enum UpdatePointsRequestTypeEnum {
    Deduct = 'deduct',
    Add = 'add'
}

/**
 * 
 * @export
 * @interface VoucheryCoupon
 */
export interface VoucheryCoupon {
    /**
     * 
     * @type {string}
     * @memberof VoucheryCoupon
     */
    id?: string;
    /**
     * 
     * @type {string}
     * @memberof VoucheryCoupon
     */
    type?: string;
    /**
     * 
     * @type {number}
     * @memberof VoucheryCoupon
     */
    campaign_id?: number;
    /**
     * 
     * @type {boolean}
     * @memberof VoucheryCoupon
     */
    active?: boolean;
    /**
     * 
     * @type {string}
     * @memberof VoucheryCoupon
     */
    code?: string;
    /**
     * 
     * @type {string}
     * @memberof VoucheryCoupon
     */
    created_at?: string;
    /**
     * 
     * @type {string}
     * @memberof VoucheryCoupon
     */
    updated_at?: string;
    /**
     * 
     * @type {string}
     * @memberof VoucheryCoupon
     */
    qr_code_url?: string;
    /**
     * 
     * @type {number}
     * @memberof VoucheryCoupon
     */
    value_left?: number;
    /**
     * 
     * @type {string}
     * @memberof VoucheryCoupon
     */
    status?: string;
    /**
     * 
     * @type {VoucheryCustomer}
     * @memberof VoucheryCoupon
     */
    customer?: VoucheryCustomer;
}
/**
 * 
 * @export
 * @interface VoucheryCustomer
 */
export interface VoucheryCustomer {
    /**
     * 
     * @type {string}
     * @memberof VoucheryCustomer
     */
    identifier?: string;
    /**
     * 
     * @type {number}
     * @memberof VoucheryCustomer
     */
    loyalty_points?: number;
}
/**
 * 
 * @export
 * @interface VoucheryExistingCoupon
 */
export interface VoucheryExistingCoupon {
    /**
     * 
     * @type {string}
     * @memberof VoucheryExistingCoupon
     */
    campaign_id: string;
}
/**
 * 
 * @export
 * @interface VoucheryNewCoupon
 */
export interface VoucheryNewCoupon {
    /**
     * 
     * @type {string}
     * @memberof VoucheryNewCoupon
     */
    prefix?: string;
    /**
     * 
     * @type {string}
     * @memberof VoucheryNewCoupon
     */
    campaign_id: string;
}
/**
 * 
 * @export
 * @interface VoucheryNewCustomer
 */
export interface VoucheryNewCustomer {
    /**
     * 
     * @type {string}
     * @memberof VoucheryNewCustomer
     */
    customer_id: string;
}
/**
 * 
 * @export
 * @interface VoucheryRedemption
 */
export interface VoucheryRedemption {
    /**
     * 
     * @type {number}
     * @memberof VoucheryRedemption
     */
    granted_discount?: number;
    /**
     * 
     * @type {boolean}
     * @memberof VoucheryRedemption
     */
    confirmed?: boolean;
    /**
     * 
     * @type {string}
     * @memberof VoucheryRedemption
     */
    code: string;
    /**
     * 
     * @type {number}
     * @memberof VoucheryRedemption
     */
    transaction_cost: number;
}
/**
 * 
 * @export
 * @interface VoucheryTrigger
 */
export interface VoucheryTrigger {
    /**
     * 
     * @type {string}
     * @memberof VoucheryTrigger
     */
    name: string;
}
/**
 * 
 * @export
 * @interface VoucheryTriggerResponse
 */
export interface VoucheryTriggerResponse {
    /**
     * 
     * @type {number}
     * @memberof VoucheryTriggerResponse
     */
    loyalty_points: number;
}

/**
 * VoucheryApi - axios parameter creator
 * @export
 */
export const VoucheryApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Assign existing coupon
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryExistingCoupon} [voucheryExistingCoupon] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        assignExistingCoupon: async (organizationId: string, projectId: string, customerId: string, voucheryExistingCoupon?: VoucheryExistingCoupon, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('assignExistingCoupon', 'organizationId', organizationId)
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('assignExistingCoupon', 'projectId', projectId)
            // verify required parameter 'customerId' is not null or undefined
            assertParamExists('assignExistingCoupon', 'customerId', customerId)
            const localVarPath = `/organizations/{organizationId}/projects/{projectId}/customers/{customerId}/assign-coupons`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)))
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"customerId"}}`, encodeURIComponent(String(customerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(voucheryExistingCoupon, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Creates customer in Vouchery
         * @summary Create customer
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {VoucheryNewCustomer} [voucheryNewCustomer] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createCustomer: async (organizationId: string, projectId: string, voucheryNewCustomer?: VoucheryNewCustomer, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('createCustomer', 'organizationId', organizationId)
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('createCustomer', 'projectId', projectId)
            const localVarPath = `/organizations/{organizationId}/projects/{projectId}/customers`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)))
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(voucheryNewCustomer, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Creates coupon assigned to customer
         * @summary Create customer coupon
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryNewCoupon} [voucheryNewCoupon] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createCustomerCoupon: async (organizationId: string, projectId: string, customerId: string, voucheryNewCoupon?: VoucheryNewCoupon, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('createCustomerCoupon', 'organizationId', organizationId)
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('createCustomerCoupon', 'projectId', projectId)
            // verify required parameter 'customerId' is not null or undefined
            assertParamExists('createCustomerCoupon', 'customerId', customerId)
            const localVarPath = `/organizations/{organizationId}/projects/{projectId}/customers/{customerId}/coupons`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)))
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"customerId"}}`, encodeURIComponent(String(customerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(voucheryNewCoupon, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Creates Vouchery trigger (adds loyalty points)
         * @summary Create trigger
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryTrigger} [voucheryTrigger] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createTrigger: async (organizationId: string, projectId: string, customerId: string, voucheryTrigger?: VoucheryTrigger, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('createTrigger', 'organizationId', organizationId)
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('createTrigger', 'projectId', projectId)
            // verify required parameter 'customerId' is not null or undefined
            assertParamExists('createTrigger', 'customerId', customerId)
            const localVarPath = `/organizations/{organizationId}/projects/{projectId}/customers/{customerId}/triggers`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)))
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"customerId"}}`, encodeURIComponent(String(customerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(voucheryTrigger, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get Vouchery customer by ID
         * @summary Get customer
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCustomer: async (organizationId: string, projectId: string, customerId: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('getCustomer', 'organizationId', organizationId)
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getCustomer', 'projectId', projectId)
            // verify required parameter 'customerId' is not null or undefined
            assertParamExists('getCustomer', 'customerId', customerId)
            const localVarPath = `/organizations/{organizationId}/projects/{projectId}/customers/{customerId}`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)))
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"customerId"}}`, encodeURIComponent(String(customerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * List active coupons of Vouchery customer
         * @summary Get customer coupons
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCustomerCoupons: async (organizationId: string, projectId: string, customerId: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('getCustomerCoupons', 'organizationId', organizationId)
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getCustomerCoupons', 'projectId', projectId)
            // verify required parameter 'customerId' is not null or undefined
            assertParamExists('getCustomerCoupons', 'customerId', customerId)
            const localVarPath = `/organizations/{organizationId}/projects/{projectId}/customers/{customerId}/coupons`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)))
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"customerId"}}`, encodeURIComponent(String(customerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get available point rewards
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPointRewards: async (organizationId: string, projectId: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('getPointRewards', 'organizationId', organizationId)
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getPointRewards', 'projectId', projectId)
            const localVarPath = `/organizations/{organizationId}/projects/{projectId}/point-rewards`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)))
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Redeem coupon
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryRedemption} [voucheryRedemption] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        redeemCoupon: async (organizationId: string, projectId: string, customerId: string, voucheryRedemption?: VoucheryRedemption, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('redeemCoupon', 'organizationId', organizationId)
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('redeemCoupon', 'projectId', projectId)
            // verify required parameter 'customerId' is not null or undefined
            assertParamExists('redeemCoupon', 'customerId', customerId)
            const localVarPath = `/organizations/{organizationId}/projects/{projectId}/customers/{customerId}/redemptions`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)))
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"customerId"}}`, encodeURIComponent(String(customerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(voucheryRedemption, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update customer points
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {UpdatePointsRequest} [updatePointsRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateCustomerPoints: async (organizationId: string, projectId: string, customerId: string, updatePointsRequest?: UpdatePointsRequest, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('updateCustomerPoints', 'organizationId', organizationId)
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('updateCustomerPoints', 'projectId', projectId)
            // verify required parameter 'customerId' is not null or undefined
            assertParamExists('updateCustomerPoints', 'customerId', customerId)
            const localVarPath = `/organizations/{organizationId}/projects/{projectId}/customers/{customerId}/points`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)))
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"customerId"}}`, encodeURIComponent(String(customerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updatePointsRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * VoucheryApi - functional programming interface
 * @export
 */
export const VoucheryApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = VoucheryApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Assign existing coupon
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryExistingCoupon} [voucheryExistingCoupon] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async assignExistingCoupon(organizationId: string, projectId: string, customerId: string, voucheryExistingCoupon?: VoucheryExistingCoupon, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VoucheryCoupon>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.assignExistingCoupon(organizationId, projectId, customerId, voucheryExistingCoupon, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Creates customer in Vouchery
         * @summary Create customer
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {VoucheryNewCustomer} [voucheryNewCustomer] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createCustomer(organizationId: string, projectId: string, voucheryNewCustomer?: VoucheryNewCustomer, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VoucheryCustomer>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createCustomer(organizationId, projectId, voucheryNewCustomer, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Creates coupon assigned to customer
         * @summary Create customer coupon
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryNewCoupon} [voucheryNewCoupon] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createCustomerCoupon(organizationId: string, projectId: string, customerId: string, voucheryNewCoupon?: VoucheryNewCoupon, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VoucheryCoupon>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createCustomerCoupon(organizationId, projectId, customerId, voucheryNewCoupon, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Creates Vouchery trigger (adds loyalty points)
         * @summary Create trigger
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryTrigger} [voucheryTrigger] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createTrigger(organizationId: string, projectId: string, customerId: string, voucheryTrigger?: VoucheryTrigger, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VoucheryTriggerResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createTrigger(organizationId, projectId, customerId, voucheryTrigger, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Get Vouchery customer by ID
         * @summary Get customer
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getCustomer(organizationId: string, projectId: string, customerId: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VoucheryCustomer>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getCustomer(organizationId, projectId, customerId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * List active coupons of Vouchery customer
         * @summary Get customer coupons
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getCustomerCoupons(organizationId: string, projectId: string, customerId: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<VoucheryCoupon>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getCustomerCoupons(organizationId, projectId, customerId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get available point rewards
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getPointRewards(organizationId: string, projectId: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<object>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getPointRewards(organizationId, projectId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Redeem coupon
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryRedemption} [voucheryRedemption] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async redeemCoupon(organizationId: string, projectId: string, customerId: string, voucheryRedemption?: VoucheryRedemption, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VoucheryRedemption>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.redeemCoupon(organizationId, projectId, customerId, voucheryRedemption, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update customer points
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {UpdatePointsRequest} [updatePointsRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateCustomerPoints(organizationId: string, projectId: string, customerId: string, updatePointsRequest?: UpdatePointsRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VoucheryCustomer>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateCustomerPoints(organizationId, projectId, customerId, updatePointsRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * VoucheryApi - factory interface
 * @export
 */
export const VoucheryApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = VoucheryApiFp(configuration)
    return {
        /**
         * 
         * @summary Assign existing coupon
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryExistingCoupon} [voucheryExistingCoupon] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        assignExistingCoupon(organizationId: string, projectId: string, customerId: string, voucheryExistingCoupon?: VoucheryExistingCoupon, options?: any): AxiosPromise<VoucheryCoupon> {
            return localVarFp.assignExistingCoupon(organizationId, projectId, customerId, voucheryExistingCoupon, options).then((request) => request(axios, basePath));
        },
        /**
         * Creates customer in Vouchery
         * @summary Create customer
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {VoucheryNewCustomer} [voucheryNewCustomer] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createCustomer(organizationId: string, projectId: string, voucheryNewCustomer?: VoucheryNewCustomer, options?: any): AxiosPromise<VoucheryCustomer> {
            return localVarFp.createCustomer(organizationId, projectId, voucheryNewCustomer, options).then((request) => request(axios, basePath));
        },
        /**
         * Creates coupon assigned to customer
         * @summary Create customer coupon
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryNewCoupon} [voucheryNewCoupon] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createCustomerCoupon(organizationId: string, projectId: string, customerId: string, voucheryNewCoupon?: VoucheryNewCoupon, options?: any): AxiosPromise<VoucheryCoupon> {
            return localVarFp.createCustomerCoupon(organizationId, projectId, customerId, voucheryNewCoupon, options).then((request) => request(axios, basePath));
        },
        /**
         * Creates Vouchery trigger (adds loyalty points)
         * @summary Create trigger
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryTrigger} [voucheryTrigger] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createTrigger(organizationId: string, projectId: string, customerId: string, voucheryTrigger?: VoucheryTrigger, options?: any): AxiosPromise<VoucheryTriggerResponse> {
            return localVarFp.createTrigger(organizationId, projectId, customerId, voucheryTrigger, options).then((request) => request(axios, basePath));
        },
        /**
         * Get Vouchery customer by ID
         * @summary Get customer
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCustomer(organizationId: string, projectId: string, customerId: string, options?: any): AxiosPromise<VoucheryCustomer> {
            return localVarFp.getCustomer(organizationId, projectId, customerId, options).then((request) => request(axios, basePath));
        },
        /**
         * List active coupons of Vouchery customer
         * @summary Get customer coupons
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCustomerCoupons(organizationId: string, projectId: string, customerId: string, options?: any): AxiosPromise<Array<VoucheryCoupon>> {
            return localVarFp.getCustomerCoupons(organizationId, projectId, customerId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get available point rewards
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPointRewards(organizationId: string, projectId: string, options?: any): AxiosPromise<object> {
            return localVarFp.getPointRewards(organizationId, projectId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Redeem coupon
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {VoucheryRedemption} [voucheryRedemption] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        redeemCoupon(organizationId: string, projectId: string, customerId: string, voucheryRedemption?: VoucheryRedemption, options?: any): AxiosPromise<VoucheryRedemption> {
            return localVarFp.redeemCoupon(organizationId, projectId, customerId, voucheryRedemption, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update customer points
         * @param {string} organizationId 
         * @param {string} projectId 
         * @param {string} customerId 
         * @param {UpdatePointsRequest} [updatePointsRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateCustomerPoints(organizationId: string, projectId: string, customerId: string, updatePointsRequest?: UpdatePointsRequest, options?: any): AxiosPromise<VoucheryCustomer> {
            return localVarFp.updateCustomerPoints(organizationId, projectId, customerId, updatePointsRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * VoucheryApi - object-oriented interface
 * @export
 * @class VoucheryApi
 * @extends {BaseAPI}
 */
export class VoucheryApi extends BaseAPI {
    /**
     * 
     * @summary Assign existing coupon
     * @param {string} organizationId 
     * @param {string} projectId 
     * @param {string} customerId 
     * @param {VoucheryExistingCoupon} [voucheryExistingCoupon] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoucheryApi
     */
    public assignExistingCoupon(organizationId: string, projectId: string, customerId: string, voucheryExistingCoupon?: VoucheryExistingCoupon, options?: any) {
        return VoucheryApiFp(this.configuration).assignExistingCoupon(organizationId, projectId, customerId, voucheryExistingCoupon, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Creates customer in Vouchery
     * @summary Create customer
     * @param {string} organizationId 
     * @param {string} projectId 
     * @param {VoucheryNewCustomer} [voucheryNewCustomer] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoucheryApi
     */
    public createCustomer(organizationId: string, projectId: string, voucheryNewCustomer?: VoucheryNewCustomer, options?: any) {
        return VoucheryApiFp(this.configuration).createCustomer(organizationId, projectId, voucheryNewCustomer, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Creates coupon assigned to customer
     * @summary Create customer coupon
     * @param {string} organizationId 
     * @param {string} projectId 
     * @param {string} customerId 
     * @param {VoucheryNewCoupon} [voucheryNewCoupon] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoucheryApi
     */
    public createCustomerCoupon(organizationId: string, projectId: string, customerId: string, voucheryNewCoupon?: VoucheryNewCoupon, options?: any) {
        return VoucheryApiFp(this.configuration).createCustomerCoupon(organizationId, projectId, customerId, voucheryNewCoupon, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Creates Vouchery trigger (adds loyalty points)
     * @summary Create trigger
     * @param {string} organizationId 
     * @param {string} projectId 
     * @param {string} customerId 
     * @param {VoucheryTrigger} [voucheryTrigger] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoucheryApi
     */
    public createTrigger(organizationId: string, projectId: string, customerId: string, voucheryTrigger?: VoucheryTrigger, options?: any) {
        return VoucheryApiFp(this.configuration).createTrigger(organizationId, projectId, customerId, voucheryTrigger, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Get Vouchery customer by ID
     * @summary Get customer
     * @param {string} organizationId 
     * @param {string} projectId 
     * @param {string} customerId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoucheryApi
     */
    public getCustomer(organizationId: string, projectId: string, customerId: string, options?: any) {
        return VoucheryApiFp(this.configuration).getCustomer(organizationId, projectId, customerId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * List active coupons of Vouchery customer
     * @summary Get customer coupons
     * @param {string} organizationId 
     * @param {string} projectId 
     * @param {string} customerId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoucheryApi
     */
    public getCustomerCoupons(organizationId: string, projectId: string, customerId: string, options?: any) {
        return VoucheryApiFp(this.configuration).getCustomerCoupons(organizationId, projectId, customerId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get available point rewards
     * @param {string} organizationId 
     * @param {string} projectId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoucheryApi
     */
    public getPointRewards(organizationId: string, projectId: string, options?: any) {
        return VoucheryApiFp(this.configuration).getPointRewards(organizationId, projectId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Redeem coupon
     * @param {string} organizationId 
     * @param {string} projectId 
     * @param {string} customerId 
     * @param {VoucheryRedemption} [voucheryRedemption] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoucheryApi
     */
    public redeemCoupon(organizationId: string, projectId: string, customerId: string, voucheryRedemption?: VoucheryRedemption, options?: any) {
        return VoucheryApiFp(this.configuration).redeemCoupon(organizationId, projectId, customerId, voucheryRedemption, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update customer points
     * @param {string} organizationId 
     * @param {string} projectId 
     * @param {string} customerId 
     * @param {UpdatePointsRequest} [updatePointsRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoucheryApi
     */
    public updateCustomerPoints(organizationId: string, projectId: string, customerId: string, updatePointsRequest?: UpdatePointsRequest, options?: any) {
        return VoucheryApiFp(this.configuration).updateCustomerPoints(organizationId, projectId, customerId, updatePointsRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


